/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	
	ProcessConstants.ROOTSERVICESXML = net.jazz.ajax._contextRoot + "/rootservices"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_DC = "http://purl.org/dc/terms/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC = "http://open-services.net/xmlns/discovery/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_CM = "http://open-services.net/xmlns/cm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_QM = "http://open-services.net/xmlns/qm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_OSLC_RM = "http://open-services.net/xmlns/rm/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JP = "http://jazz.net/xmlns/prod/jazz/process/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JD = "http://jazz.net/xmlns/prod/jazz/discovery/1.0/"; //$NON-NLS-1$
	ProcessConstants.NAMESPACE_JFS = "http://jazz.net/xmlns/prod/jazz/jfs/1.0/"; //$NON-NLS-1$
	ProcessConstants.CONTENT_TYPE_APPLICATION_XML = "application/xml"; //$NON-NLS-1$
	// Must be kept in sync with the matching constants in
	// PermissionPath.java
	ProcessConstants.PERMISSION_PATH_SEPARATOR = "~#_~#"; //$NON-NLS-1$
	ProcessConstants.PERMISSION_PATH_DELIMITER = ":~_:~"; //$NON-NLS-1$
	ProcessConstants.NONE = "none"; //$NON-NLS-1$
	ProcessConstants.BLOCK = "block"; //$NON-NLS-1$
	ProcessConstants.DIV = "div"; //$NON-NLS-1$
	ProcessConstants.EMPTY = ""; //$NON-NLS-1$
	ProcessConstants.INLINE = "inline"; //$NON-NLS-1$
	ProcessConstants.BR = "br"; //$NON-NLS-1$
	ProcessConstants.STALE_DATA_EXCEPTION = "com.ibm.team.repository.common.StaleDataException"; //$NON-NLS-1$
	ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION = "com.ibm.team.process.common.advice.TeamOperationCanceledException"; //$NON-NLS-1$
	ProcessConstants.PERMISSION_DENIED_EXCEPTION = "com.ibm.team.repository.commo.PermissionDeniedException"; //$NON-NLS-1$ 
	ProcessConstants.SC_FORBIDDEN = 403;
	ProcessConstants.PREFIX = "com.ibm.team.process.";//$NON-NLS-1$
	ProcessConstants.ERROR_PRIORITY_HIGH = 100;
	ProcessConstants.ERROR_PRIORITY_LOW = -500;
	ProcessConstants.ERROR_PRIORITY_WARNING = -999;
	ProcessConstants.ERROR_PRIORITY_WARNING_LOW = -1999;
	
	ProcessConstants.DEFAULT_ROLE_ID = "default"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_ERROR_TYPE = "error"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_NOT_LOADED_TYPE = "notLoaded"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_TYPE = "serviceProvider"; //$NON-NLS-1$
	ProcessConstants.SERVICE_PROVIDER_CATALOG_TYPE = "serviceProviderCatalog"; //$NON-NLS-1$
	ProcessConstants.ITERATION_TYPE_NONE = 'com.ibm.team.process.internal.iteration.type.none'; //$NON-NLS-1$
	ProcessConstants.IterationTypeDTO = {
		ID: "id", //$NON-NLS-1$
		ITEM_ID: "itemId", //$NON-NLS-1$
		LABEL: "label" //$NON-NLS-1$
	};
	
	ProcessConstants.PermissionDTO = {
		ID: "id", //$NON-NLS-1$
		NAME: "name", //$NON-NLS-1$
		ITEMS: "items", //$NON-NLS-1$
		DESCRIPTION: "description" //$NON-NLS-1$
	};
	
	ProcessConstants.PermissionConfigurationDTO = {
		SELECTED: "selected", //$NON-NLS-1$
		CONFIGURED: "configured", //$NON-NLS-1$
		FINAL_OP: "finalOp", //$NON-NLS-1$
		DENIAL_EXPLANATION: "denialExplanation" //$NON-NLS-1$
	};
	
	ProcessConstants.PermissionsScopeContext = {
		PROJECT: 'project', //$NON-NLS-1$
		TEAM: 'team', //$NON-NLS-1$
		DEV_LINES: 'devLines', //$NON-NLS-1$
		ITERATION_TYPES: 'iterationTypes', //$NON-NLS-1$
		ITERATIONS: 'iterations' //$NON-NLS-1$	
	};
	
	ProcessConstants.PermissionContext = {
		PROJECT: 1,
		TEAM: 2,
		DEV_LINE: 3,
		ITERATION_TYPE: 4,
		ITERATION: 5
	};
	
	ProcessConstants.EditorContext = {
		PROJECT: 1,
		TEAM: 2
	};
	
	ProcessConstants.TabEnum = {
		OVERVIEW: "com.ibm.team.process.web.Overview", //$NON-NLS-1$
		PERMISSIONS: "com.ibm.team.process.web.Permissions", //$NON-NLS-1$
		ROLES: "com.ibm.team.process.web.Roles", //$NON-NLS-1$
		ACCESS_CONTROL: "com.ibm.team.process.web.AccessControl", //$NON-NLS-1$
		TIMELINE: "com.ibm.team.process.web.Timelines" //$NON-NLS-1$
	};
	
	ProcessConstants.EditorMode = {
		PREVIEW: "Preview", //$NON-NLS-1$
		EDIT: "Edit", //$NON-NLS-1$
		NEW: "new" //$NON-NLS-1$
	};
	
	ProcessConstants.RoleCardinality = {
		MANY: 0,
		SINGLE: 1
	};
	
	ProcessConstants.LinkTypes = {
		IMPLEMENTS: "implements", //$NON-NLS-1$
		IMPLEMENTED_BY: "implemented-by", //$NON-NLS-1$
		VALIDATES: "validates", //$NON-NLS-1$
		VALIDATED_BY: "validated-by", //$NON-NLS-1$
		TESTS: "tests", //$NON-NLS-1$
		TESTED_BY: "tested-by", //$NON-NLS-1$
		RELATED_TO: "related-to" //$NON-NLS-1$
	};
	
	ProcessConstants.ServiceProviderTypes = {
		CM: "cmServiceProviders", //$NON-NLS-1$
		RM: "rmServiceProviders", //$NON-NLS-1$
		QM: "qmServiceProviders" //$NON-NLS-1$
	};
	
	ProcessConstants.CSSClass = {
		ACTION_COLUMN: "action-column", //$NON-NLS-1$
		TOOLBAR_TABLE: "toolbar-table", //$NON-NLS-1$
		TABLE_ROW_SELECTED: "selected" //$NON-NLS-1$
	};
	
	ProcessConstants.ProjectSelectorContext = {
		ADD: "jazz.app.events.contextSwitcher.addContext", //$NON-NLS-1$
		DELETE: "jazz.app.events.contextSwitcher.deleteContext" //$NON-NLS-1$
	};
	
	ProcessConstants.ProjectAreaExtensionPage = {
		EXTENSION_POINT_PROFILE_PAGES: "com.ibm.team.process.web.projectAreaEditorPages",  //$NON-NLS-1$
		ELEMENT_PAGE: "page",  //$NON-NLS-1$
		ATTRIBUTE_ID: "id",  //$NON-NLS-1$
		ATTRIBUTE_TITLE: "title",  //$NON-NLS-1$
		ATTRIBUTE_WIDGET: "widget"  //$NON-NLS-1$
	};
	
	
})();
