/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportParamTime");

dojo.require("dojo.i18n");
dojo.require("dojo.date.locale");

dojo.require("dijit.form.TimeTextBox");

dojo.require("com.ibm.team.reports.web.ui.internal.ReportParam");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
    dojo.declare("com.ibm.team.reports.web.ui.internal.ReportParamTime", [com.ibm.team.reports.web.ui.internal.ReportParam], {
        templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportParamTime.html"),
		
		widgetsInTemplate: true,
		
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
        
		postCreate: function() {
			var self = this;
			dojo.connect(this.timeTextBox, "onChange", this, function(arg) {
				self.onDirty();
			});
		},		

		getSelectedValues: function() {
			var time = this.timeTextBox.getValue();
			if (!time || time.length == 0) {
				return null;
			}
			var minutes = time.getMinutes();
			var zero = "";
			if (minutes < 10) {
				zero = "0";
			}
			return [time.getHours() + ":" + zero + minutes];
		},
		
		setDefaultValues: function() {
			if (this.parameterDTO.defaultValue) {
				this.timeTextBox.setDisplayedValue(this.parameterDTO.defaultValue);
			}
		},
		
		setValues: function(values) {
			if (values && values.length > 0) {
				this.timeTextBox.setDisplayedValue(values);
			}
			if (!this.isInputEnabled) {
				this.disableInput();	
			}
		},
		
		remoteError: function(error) {
			alert(error.message);
		}
		
	});
	
})();
