/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
(function(){

	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog", com.ibm.team.repository.web.ui.internal.TeamContributorSelectionDialog, { //$NON-NLS-1$
		constructor: function(){
			//this is called messages2 to avoid replacing the messages field in the parent class
			this.messages2 = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		runContribSearch: function(params, srh){
			ProcessClient.getContributors(params, srh);
		},
		
		getDispValue: function(elem){
			var processAreas = [];
			if (elem.processAreas != null) {
				for (var j = 0; j < elem.processAreas.length; j++) {
					processAreas.push(elem.processAreas[j].name);
				}
			}
			var disp;
			if (processAreas.length > 0) {
				disp = dojo.string.substitute(this.messages2.TeamContributorSelectionDialog_2, [elem.name, elem.userId, processAreas.sort().join(", ")]);//$NON-NLS-1$
			} else {
				disp = dojo.string.substitute(this.messages2.TeamContributorSelectionDialog_1, [elem.name, elem.userId]);
			}
			return disp;
		}
	});
	
})();
