/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.Button"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.data.dom"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
(function(){

	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/RolesEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function(arg){
			this.editor = arg.editor;
			this.roles = arg.editor.definedRoles;
			this.originalRoles = arg.editor.originalDefinedRoles;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._downIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/down.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._downIconSrcDisabled = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/down-disabled.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._upIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/up.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._upIconSrcDisabled = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/up-disabled.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._addIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/addRole.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._removeIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/delete_hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this._removeIconSrcDisabled = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/delete.gif"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this.connect(this.identifier, "onkeyup", "_handleIdentifierChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.name, "onkeyup", "_handleNameChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.description, "onkeyup", "_handleDescriptionChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.rolesList, "onchange", "_handleRoleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.singleCardinality, "onclick", "_handleCardinalityChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.manyCardinality, "onclick", "_handleCardinalityChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.refresh();
		},
		
		refresh: function(){
			this._clearState();
			
			this.editor.addSaveParticipant(this, "com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
			this.roles = this.editor.definedRoles;
			this.originalRoles = this.editor.originalDefinedRoles;
			this._populateRolesSelect();
			
		},
		
		_clearState: function(){
			this.editor.removeSaveParticipant("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
			
			this.rolesList.selectedIndex = -1;
			this.rolesList.options.length = 0;
			this.identifier.value = ProcessConstants.EMPTY;
			this.name.value = ProcessConstants.EMPTY;
			this.singleCardinality.checked = false;
			this.manyCardinality.checked = true;
			
		},
		
		_populateRolesSelect: function(){
			if (this.roles.length > 0) {
				dojo.forEach(this.roles, function(role){
					this._addRoleToSelect(role, false);
					role.savedValue = {};
					role.savedValue.id = role.id;
					role.savedValue.label = role.label;
					role.savedValue.description = role.description;
					role.savedValue.cardinality = role.cardinality;
				}, this);
				this.rolesList.options[0].selected = true;
				this._populateRoleData(this.roles[0]);
				this._toggleActionLink(true, this.removeRoleLink, this.removeRoleImg, this._removeIconSrc);
				this._toggleEditControls(false);
			} else {
				this._toggleEditControls(true);
			}
			this._updateUpDownActions();
		},
		
		_addRoleToSelect: function(role, useRoleIdForText){
			var text = role.label;
			if (useRoleIdForText === true) {
				text = role.id;
			}
			var anOption = new Option(text, role.id);
			var optionArr = this.rolesList.options;
			optionArr[optionArr.length] = anOption;
		},
		
		_handleRoleChange: function(event){
			var index = this.rolesList.selectedIndex;
			if (index !== -1) {
				var role = this.roles[index];
				this._populateRoleData(role);
				this._validateRole(role, true);
				this._toggleActionLink(true, this.removeRoleLink, this.removeRoleImg, this._removeIconSrc);
				this._toggleEditControls(false);
			}
			this._updateUpDownActions();
		},
		
		_populateRoleData: function(role){
			this.singleCardinality.defaultChecked = false;
			this.manyCardinality.defaultChecked = false;
			
			this.name.value = role.label;
			this.identifier.value = role.id;
			this.description.value = role.description;
			if (role.cardinality === ProcessConstants.RoleCardinality.SINGLE) {
				this.singleCardinality.checked = true;
				this.singleCardinality.defaultChecked = true;
			} else {
				this.manyCardinality.checked = true;
				this.manyCardinality.defaultChecked = true;
			}
		},
		
		_addRole: function(e){
			dojo.stopEvent(e);
			var newRole = {
				id: this.messages.RolesEditor_DefaultIdentifier,
				label: ProcessConstants.EMPTY,
				description: ProcessConstants.EMPTY,
				cardinality: ProcessConstants.RoleCardinality.MANY,
				savedValue: {}
			};
			this.roles.push(newRole);
			this._addRoleToSelect(newRole, true);
			this._populateRoleData(newRole);
			this.rolesList.options[this.rolesList.options.length - 1].selected = true;
			this._toggleActionLink(true, this.removeRoleLink, this.removeRoleImg, this._removeIconSrc);
			this._toggleEditControls(false);
			this._updateUpDownActions();
			this._validateRole(newRole, true);
			this.editor.setDirty(this.changesPending());
		},
		
		_removeRole: function(e){
			dojo.stopEvent(e);
			if (this.removeRoleLink.href && this.removeRoleLink.href !== ProcessConstants.EMPTY) {
				if (confirm(this.messages.RolesEditor_RemoveProcessRole)) {
					var selectedIndex = this.rolesList.selectedIndex;
					this.roles.splice(selectedIndex, 1);
					this.rolesList.options[selectedIndex] = null;
					var emptyRole = {
						id: ProcessConstants.EMPTY,
						label: ProcessConstants.EMPTY,
						description: ProcessConstants.EMPTY,
						cardinality: ProcessConstants.RoleCardinality.MANY
					};
					this._populateRoleData(emptyRole);
					this._toggleActionLink(false, this.removeRoleLink, this.removeRoleImg, this._removeIconSrcDisabled);
					this._toggleEditControls(true);
					this._updateUpDownActions();
					this.editor._clearMessage();
					this.editor.setDirty(this.changesPending());
				}
			}
		},
		
		_moveRoleUp: function(e){
			dojo.stopEvent(e);
			if (this.upRoleLink.href && this.upRoleLink.href !== ProcessConstants.EMPTY) {
				var selectedIndex = this.rolesList.selectedIndex;
				if (selectedIndex !== -1) {
					var previousRole = this.roles[selectedIndex - 1];
					this.roles[selectedIndex - 1] = this.roles[selectedIndex];
					this.roles[selectedIndex] = previousRole;
					
					var currentOption = this.rolesList.options[selectedIndex];
					this.rolesList.removeChild(currentOption);
					this.rolesList.insertBefore(currentOption, this.rolesList[selectedIndex -1]);
					
					this._updateUpDownActions();
					this.editor.setDirty(this.changesPending());
				}
			}
		},
		
		_moveRoleDown: function(e){
			dojo.stopEvent(e);
			if (this.downRoleLink.href && this.downRoleLink.href !== ProcessConstants.EMPTY) {
				var selectedIndex = this.rolesList.selectedIndex;
				if (selectedIndex !== -1) {
					var nextRole = this.roles[selectedIndex + 1];
					this.roles[selectedIndex + 1] = this.roles[selectedIndex];
					this.roles[selectedIndex] = nextRole;
					
					var currentOption = this.rolesList.options[selectedIndex];
					var nextOption = this.rolesList.options[selectedIndex + 1];
					
					this.rolesList.removeChild(currentOption);
					this.rolesList.replaceChild(currentOption, nextOption);
					this.rolesList.insertBefore(nextOption, currentOption);
					
					this._updateUpDownActions();
					this.editor.setDirty(this.changesPending());
				}
			}
		},
		_toggleActionLink: function(enable, actionLink, actionLinkImage, actionLinkImageSrc){
			actionLinkImage.src = actionLinkImageSrc;
			if (enable === true) {
				// Add an href so it acts enabled
				actionLink.href = "#"; //$NON-NLS-1$ 
			} else {
				if (actionLink.href) {
					// Remove the href so it acts disabled
					actionLink.removeAttribute('href'); //$NON-NLS-1$ 
				}
			}
			
		},
		
		_handleIdentifierChange: function(event){
			var id = dojo.string.trim(event.target.value);
			var index = this.rolesList.selectedIndex;
			if (index !== -1) {
				var role = this.roles[index];
				role.id = id;
				// If the role id is empty paint the option to indicate so
				dojo.toggleClass(this.rolesList.options[index], "errorOption", id.length === 0); //$NON-NLS-1$
				if (!role.label || role.label.length === 0) {
					if (id.length === 0) {
						this.rolesList.options[index].text = "<" + this.messages.RolesEditor_IdentifierRequired + ">"; //$NON-NLS-1$ //$NON-NLS-2$
					} else {
						this.rolesList.options[index].text = id;
					}
				}
				this.editor.setDirty(this.changesPending());
				this._validateRole(role, true);
			}
			
		},
		
		_handleNameChange: function(event){
			var label = dojo.string.trim(event.target.value);
			var text = label;
			if (label.length === 0) {
				text = this.identifier.value;
				if (text.length === 0) {
					text = "<" + this.messages.RolesEditor_IdentifierRequired + ">"; //$NON-NLS-1$ //$NON-NLS-2$
				}
			}
			var index = this.rolesList.selectedIndex;
			if (index !== -1) {
				this.roles[index].label = label;
				this.rolesList.options[index].text = text;
			}
			this.editor.setDirty(this.changesPending());
		},
		
		_handleDescriptionChange: function(event){
			var description = dojo.string.trim(event.target.value);
			var index = this.rolesList.selectedIndex;
			if (index !== -1) {
				this.roles[index].description = description;
			}
			this.editor.setDirty(this.changesPending());
		},
		
		_handleCardinalityChange: function(event){
			this.singleCardinality.defaultChecked = false;
			this.manyCardinality.defaultChecked = false;
			
			event.target.defaultChecked = event.target.checked;
			
			var cardinality = ProcessConstants.RoleCardinality.MANY;
			if (event.target === this.singleCardinality) {
				cardinality = ProcessConstants.RoleCardinality.SINGLE;
			}
			var index = this.rolesList.selectedIndex;
			if (index !== -1) {
				this.roles[index].cardinality = cardinality;
			}
			this.editor.setDirty(this.changesPending());
		},
		
		_validateRole: function(role, displayMessage){
			var msg;
			var isError = true;
			if (role.id.length === 0) {
				msg = this.messages.RolesEditor_IdentifierMustNotBeEmpty;
			} else if (this._isDuplicateRole(role.id) === true) {
				msg = dojo.string.substitute(this.messages.RolesEditor_DuplicateIDMessage, [role.id]);
			} else if (role.savedValue.id && role.savedValue.id !== role.id) {
				// Only warn on roles that had been previously saved
				msg = this.messages.RolesEditor_ChangeRoleIDMessage;
				isError = false;
			}
			
			if (displayMessage === true) {
				if (msg) {
					if (isError === true) {
						this.editor.displayErrorMessage(msg);
					} else {
						this.editor.displayWarningMessage(msg);
					}
				} else {
					this.editor._clearMessage();
				}
			}
			
			return msg;
			
		},
		
		validateRequired: function(){
			for (var i = 0; i < this.roles.length; i++) {
				var msg = this._validateRole(this.roles[i], false);
				if (msg) {
					return msg;
				}
			}
		},
		
		canSave: function(){
			var msg = this.validateRequired();
			return msg === undefined; // If no message we can save.
		},
		
		changesPending: function(){
			var props = ["id", "label", "cardinality", "description"]; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			// Has any role changed or been added?
			for (var i = 0; i < this.roles.length; i++) {
				var role = this.roles[i];
				for (var j = 0; j < props.length; j++) {
					if (role[props[j]] !== role.savedValue[props[j]]) {
						return true;
					}
				}
			}
			
			// Has any roles been deleted?
			if (this.roles.length !== this.originalRoles.length) {
				return true;
			}
			
			// Has any role moved up or down?
			for (i = 0; i < this.roles.length; i++) {
				if (this.roles[i].id !== this.originalRoles[i].id) {
					return true;
				}
			}
			
			return false;
		},
		
		aboutToBeSaved: function() {
			// Due to a loading issue roles are control in the editor so
			// nothing to do here
		},
		
		saved: function() {
			// Due to a loading issue roles are control in the editor so
			// nothing to do here
		},
		
		_toggleEditControls: function(disabled){
			this.identifier.disabled = disabled;
			this.name.disabled = disabled;
			this.description.disabled = disabled;
			this.singleCardinality.disabled = disabled;
			this.manyCardinality.disabled = disabled;
			
		},
		
		_updateUpDownActions: function(){
			var index = this.rolesList.selectedIndex;
			var size = this.rolesList.options.length;
			if (index === -1 || size === 0) { // Nothing selected disable both icons
				this._toggleActionLink(false, this.upRoleLink, this.upRoleImg, this._upIconSrcDisabled);
				this._toggleActionLink(false, this.downRoleLink, this.downRoleImg, this._downIconSrcDisabled);
				return;
			}
			if (index !== 0) {
				this._toggleActionLink(true, this.upRoleLink, this.upRoleImg, this._upIconSrc);
			} else {
				this._toggleActionLink(false, this.upRoleLink, this.upRoleImg, this._upIconSrcDisabled);
				
			}
			if (index !== size - 1) {
				this._toggleActionLink(true, this.downRoleLink, this.downRoleImg, this._downIconSrc);
			} else {
				this._toggleActionLink(false, this.downRoleLink, this.downRoleImg, this._downIconSrcDisabled);
			}
			
		},
		
		_isDuplicateRole: function(id){
			var count = 0;
			for (var i = 0; i < this.roles.length; i++) {
				if (id === this.roles[i].id) {
					count++;
				}
			}
			return count > 1;
		},
		
		uninitialize: function(){
			this.editor.removeSaveParticipant("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
			
			delete this.editor;
			delete this.roles;
			delete this.originalRoles;
			
			this.inherited(arguments);
		}
		
	});
	
})();
