/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItem");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");

(function() {

var WidgetUtil  = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var EditorUtil 	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var EventTopics	= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget",
	[dijit._Widget, dijit._Templated, com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget],
	{
		templateString: '<div class="EnumerationWidget NarrowWidget">' +
						'<img dojoAttachPoint="_image" class="PreFieldImage" />' +
						'<div class="fieldWrapper"><select dojoAttachPoint="_select" dojoAttachEvent="onkeyup: _handleKeyUp, onchange: _handleSelectChange, onclick:_handleSelectClick, onfocus:_handleSelectFocus, onblur: _handleSelectBlur" class="Select"></select><span style="display: none;" dojoAttachPoint="_enumGuessValue" class="EnumGuessValue"></span></div>' +
						'<span style="display: none" dojoAttachPoint="_readOnlySelectValue" class="ReadOnlySelectValue"></span>' +
						'</div>',
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
		},
		postCreate: function() {
			WidgetUtil.setSpacerImage(this._image);
			this._attributePath = this._getAttributePath();
			this._savedAttributePath = this._getSavedAttributePath();
			var attributeValue = this.workingCopy.getValue({path: this._attributePath});
			if(attributeValue) {
				this.attributeValue = attributeValue;
			}
			
			if(this.creationSpec && this.creationSpec.isDescription) {
					dojo.addClass(this.domNode,"MarginLeft10");
				}
			var isAddingValueToEmptyPossibleValues = true;
			if(dojo.isFunction(this._isAddingValueToEmptyPossibleValues)) {
				isAddingValueToEmptyPossibleValues = this._isAddingValueToEmptyPossibleValues();
			}
			this._modifiers = this._modifiers ? this._modifiers : {};
			// If there are no possible values, but there is a value,
			// Add the value as a possible value, but always be disabled
			this._isAlwaysDisabled = false;
			if(this._possibleValues ==null || this._possibleValues.length == 0) {
				WidgetUtil.setSpacerImage(this._image);
				this._isAlwaysDisabled=true;
				if(attributeValue && isAddingValueToEmptyPossibleValues) { 
					this._possibleValues = [
						attributeValue
					];
				}
			}
			this._possibleValues = this._possibleValues || [];
			var value;
			
			// Set all versions of a null id to an empty string
			for (var i = 0; i < this._possibleValues.length; i++) {
				if (this._possibleValues[i] &&
				(this._possibleValues[i].id == null ||
				this._possibleValues[i].id == "" ||
				this._possibleValues[i].isNull ||
				this._possibleValues[i].id == "unassigned")) {
					this._possibleValues[i].id = "";
					this._possibleValues[i].isNull = true;
				}
			}

			// if the attribute value is null, disable and return
			if(this.attributeValue == null) {
			  this._select.disabled = true;
			  if(this._possibleValues && this._possibleValues.length > 0) {
					this._bindValuesToSelect(this._possibleValues, this._select, this._image);
			  }
			  return;
			};
			
			// Set all versions of a null id to null
			if(this.attributeValue.id == null || 
			   this.attributeValue.id == "" || 
			   this.attributeValue.isNull  || 
			   this.attributeValue.id=="unassigned"){
			   	 	 this.attributeValue.id = "";
  					 this.attributeValue.isNull = true;
			  }
			
				// if the value is not in possible values
				// then add the value as the first possible value
				if(this.attributeValue) {
					value = this.attributeValue;
					if(value) {
						var found = false;
						for(var i=0;i<this._possibleValues.length;i++) {
							if(this._possibleValues[i].id == value.id ) {
								found = true;
								break;
							}
						}
						if (!found && isAddingValueToEmptyPossibleValues) { 
							this._possibleValues.unshift(value);
						}
					}
				}

			// bindValuesToSelect will select this.attributeValue			
			value = this._bindValuesToSelect(this._possibleValues, this._select, this._image);
			
			var label = "";
			try{
				this._lastSelectedValue = this._getCurrentSelectProps(this._select);
				label = this._lastSelectedValue.label;
			} catch(e) {}; // ignore
			this._setReadOnlySelectValue(label);
			if(this._modifiers && this._modifiers.onCreate) {
					this.parentWidget[this._modifiers.onCreate](this, value);
			}
			
			/* TODO: Delete the followining */
			if(this._modifiers && this._modifiers.onValueChanged) {
					this.parentWidget[this._modifiers.onValueChanged](this , value, /* isInitialization */ true);
				}
			/* ------------------------ */
			if(this.onValueChanged) {
				this.onValueChanged(value, /* isInitialization */ true);
			}			
			
			
			if (this.workingCopy.isGuest()) {
				dojo.addClass(this._select, "GuestField");
			}
			this._isChanged = false;
			
			this.__workItemAdapter= new com.ibm.team.workitem.web.client.internal.WorkItem(this.workingCopy);
			this.workingCopy.addListener({
				path: this._attributePath,
				event: "onchange",
				listener: this,
				functionName: "_handleAttributeChange"
			});
			this.workingCopy.addListener({
				path: this._attributePath,
				event: EventTopics.ON_DEPENDENCY_CHANGE,
				listener: this,
				functionName: "_fetchValueSet"
			});
		},
//		destroyWidget: function() {
//			this.inherited(arguments);
//		},
		/*
		 * Allow attributeId to be overridden 
		 */
		_getAttributeId: function() {
			if(this._getOverrideAttributeId) {
				return this._getOverrideAttributeId();
			}
			return this.attributeId;
		},
		_getAttributePath: function() {
			return ["attributes",  this._getAttributeId()];
		},
		_getSavedAttributePath: function() {
			return ["attributes",  this._getAttributeId(), "id" ];
		},
		_handleAttributeChange: function(parms) {
			if(parms.attributeValue && parms.attributeValue.id != null) {
				this.setValue(parms.attributeValue.id, false, false, parms.attributeValue);
			} else {
				this.setValue(parms.attributeValue, false, false, parms.attributeValue); // TODO: Rationalize attribute change
			}
		},
		setReadOnly: function(isReadOnly) {
			if (isReadOnly) { 
				if (this._isChanged) {
					this.setReadOnly(false);
					return;
				}
				this._select.style.display = "none";
				this._readOnlySelectValue.style.display = "inline";
			}
			else {
				this._select.style.display = "inline";
				this._readOnlySelectValue.style.display = "none";
			}
		},
		_setReadOnlySelectValue: function(value){
			if(value == null) {
				if(this._modifiers.noValueLabel != null) {
					value = this._modifiers.noValueLabel;
				} else {
					value = this.messages.labelDefaultNullEnumerationValue;
				}
			}
			 
			dojox.data.dom.removeChildren(this._readOnlySelectValue)
			this._readOnlySelectValue.appendChild(document.createTextNode(value));
		},
		_handleKeyUp: function(e) {
			var select= EditorUtil._getOriginalTarget(e);
			var selectValue = this._getCurrentSelectProps(select);
			if(selectValue && this._lastSelectedValue) {
				if(selectValue.id != this._lastSelectedValue.id) {
					this._handleSelectChange(e);
				}
			} else {
				this._handleSelectChange(e);
			}
		},
		// doNotPropagateAgain means that this change came from a change path, so
		// do not propagate again.
		_handleSelectChange: function(e, doNotPropagateAgain, skipDirtyEvent) {
			this._isChanged=true;
			var select= EditorUtil._getOriginalTarget(e);
			var selectValue = this._getCurrentSelectProps(select);
			this._lastSelectedValue = selectValue;
			if (!selectValue) {
				if(this.parentWidget && this.parentWidget._handleDirtyingEvent) {
					this.parentWidget._handleDirtyingEvent(e);
				}
				return;
			}
			this._setReadOnlySelectValue(selectValue.label);
			if(selectValue.iconUrl) {
				this._image.src = selectValue.iconUrl;
				this._image.style.visibility="visible";
			} else {
				WidgetUtil.setSpacerImage(this._image);
			}
			
			if (select === this._select) {
				if(this._modifiers && this._modifiers.onValueChanged && this.parentWidget && this.parentWidget[this._modifiers.onValueChanged]) {
					for(var i = 0;i<this._possibleValues.length;i++) {
						if(this._possibleValues[i].id == selectValue.id) {
							selectValue.value =this._possibleValues[i];
							break; 
						}
					}					
					this.parentWidget[this._modifiers.onValueChanged](this , selectValue, /* isInitialization */ false);
				}
			}
			/*------------------------------- */
			/* Call the onValueChanged method */
			if (select === this._select) {
				if(this.onValueChanged) {
					for(var i = 0;i<this._possibleValues.length;i++) {
						if(this._possibleValues[i].id == selectValue.id) {
							selectValue.value =this._possibleValues[i];
							break; 
						}
					}					
					this.onValueChanged(selectValue, /* isInitialization */ false);
				}
			}
			/*------------------------------- */

			
			this._handleSelectFocus(e);// Use the short form of labels.
			if(!doNotPropagateAgain) {
				this.setAttributeValue(selectValue)
			}
			if(!skipDirtyEvent && this.parentWidget && this.parentWidget._handleDirtyingEvent) {
				this.parentWidget._handleDirtyingEvent(e);
			}
		},
		_handleSelectClick: function(e) {
		}, 
		_handleSelectFocus: function(e) {
			/* Special case for categories */
			if (dojo.isIE) return;
			try {
			if(!this._modifiers || !this._modifiers.allCategories) return;
			var select= EditorUtil._getOriginalTarget(e);
			var index  = select.selectedIndex;
			if(!index)return;
			var valueObject = this._possibleValues[index];
			if(!valueObject) return;
			if(select.options[index].__jazzWasClicked) return;
			select.options[index].__jazzWasClicked = true;
			var newLabel = valueObject.shortLabel;
			
			if(select.options[select.selectedIndex].childNodes[0] && 
			   select.options[select.selectedIndex].childNodes[0].nodeValue == newLabel) return;
			
			dojox.data.dom.replaceChildren(select.options[select.selectedIndex], document.createTextNode(newLabel));
			var indent = EditorUtil._getIndent(newLabel);
			if(indent > 0) {
				select.options[select.selectedIndex].style.paddingLeft= (indent * 0.4) + "em";
			} else {
				select.options[select.selectedIndex].style.paddingLeft="";
			}
			} catch(e) {};
		},
		_handleSelectBlur: function(e) {
			if (dojo.isIE) return;
			try{
			/* Special case for categories */
			if(!this._modifiers.allCategories) return;
			var select= EditorUtil._getOriginalTarget(e);
			for(var i=0;i<select.options.length;i++){
				if(select.options[i].__jazzWasClicked){
					dojox.data.dom.replaceChildren(select.options[i], document.createTextNode(select.options[i].__jazzLabel));
					var indent = EditorUtil._getIndent(select.options[i].__jazzLabel);
					if(indent > 0) {
						select.options[select.selectedIndex].style.paddingLeft= (indent * 0.4) + "em";
					} else {
						select.options[select.selectedIndex].style.paddingLeft="";
					}
					select.options[i].__jazzWasClicked = false;
				}
			}
			} catch(e) {};
		},
		setPossibleValues: function(possibleValues) {
			this._possibleValues = possibleValues;
			this._bindValuesToSelect(possibleValues, this._select)
		},
		_bindValuesToSelect: function(possibleValues, select, image) {
			var resultValue = "";
			var	selectedValueId  = select.value;
			if(selectedValueId == "") {
				selectedValueId=this.attributeValue ? this.attributeValue.id : "";
			}
			dojox.data.dom.removeChildren(select);
			
			if (!possibleValues || possibleValues.length === 0) {
				select.disabled= true;
				WidgetUtil.setSpacerImage(image);
				if(dojo.isFunction(this._getEmptyValueLabel)) {
					var label = this._getEmptyValueLabel();
				} else {
					var label = this.messages.labelDefaultNullEnumerationValue;					
				}
				if (this._modifiers.noValueLabel != null) {
					label = this._modifiers.noValueLabel;
				}
				EditorUtil._addOption(select, new Option(label, EditorUtil.UNCONFIGURED));
				return resultValue;
			} else {
				select.disabled= this._isAlwaysDisabled;
			}
			
			var defaultIndex = 0;
			for (var i = 0; i < possibleValues.length; i++) {
				if(!possibleValues[i]) continue;
				if(possibleValues[i].id == selectedValueId) {; // can be ""		
					defaultIndex= i;
					break;
				}
			}
			
			for (var i=0; i<possibleValues.length; i++) {
				if(!possibleValues[i]) continue;
				var option= EditorUtil._createOption(possibleValues[i].label, possibleValues[i].id);
				option.valueObject = possibleValues[i];
				if(possibleValues[i].title) {
					option.title=possibleValues[i].title;
				}
				 
				option[EditorUtil._getLabelProp()]= possibleValues[i].label;
	
				var isDefault = i== defaultIndex;
	
				if(isDefault) {
					resultValue = possibleValues[i];
					select.currentDefaultIndex = i;
					if(image) {
						if(possibleValues[i].iconUrl) {
							image.src = possibleValues[i].iconUrl;
							image.style.visibility="visible";	
						} else {
							WidgetUtil.setSpacerImage(image);
						}
					}
				} 
				EditorUtil._addOption(select, option, isDefault);
				if(isDefault && possibleValues[i].title) {
					select.title = possibleValues[i].title;
				}
			}
			var label = "";
			try {
				label = this._getCurrentSelectProps(this._select).label;
			} catch(e) {}; // ignore
			this._setReadOnlySelectValue(label);
		return resultValue;
	},
	setEnabled: function(isEnabled) {
		this._select.disabled = !isEnabled;
	},
	     getValue: function() {
		 	var value = this._select.value;
			return value;
		 },
		 getSelectedLabel: function() {
			if(!this._select) return "";
			return this._getCurrentSelectProps(this._select).label;
		},
		 setFormElementValues: function(retainedState){
		 	if(retainedState[this.attributeId]) {
		 		if (this._select.value != retainedState[this.attributeId]) {
					this._select.value = retainedState[this.attributeId];
					this._lastValue = retainedState[this.attributeId];
					this._isChanged = true;
//					this._setReadOnlySelectValue(this._getCurrentSelectProps(this._select).label);
					var selectValue = this._getCurrentSelectProps(this._select);
					this._setReadOnlySelectValue(selectValue.label);
					if(selectValue.iconUrl) {
						this._image.src = selectValue.iconUrl;
						this._image.style.visibility="visible";
					} else {
						WidgetUtil.setSpacerImage(this._image);
					}
				}
			}
		 },
		_getCurrentSelectProps: function(select) {
			if(select.selectedIndex == -1 || !select.options || select.options.length ==  0) return null;
			if(select.value == EditorUtil.UNCONFIGURED) return null;
			var currentOption= select.options[select.selectedIndex];
			if(!currentOption) return null;
			var props= {
				label: currentOption[EditorUtil._getLabelProp()],
				id: select.value
			};
			if(currentOption.valueObject) {
				props.iconUrl = currentOption.valueObject.iconUrl;
			}
			return props;
		},
		setAttributeValue: function(selectValue, setValue ) {
			    if (setValue) {
					this.setValue(selectValue.id);
				}
				var parms = {
					caller: this,
					path: this._attributePath,
					savedAttributePath: this._savedAttributePath,
					attributeId: this._getAttributeId(),
					value: selectValue
				};
				this.workingCopy.setValue(parms);
		},
		setValue: function(valueId, noNotify, skipDirtyingEvent, value) {
			this._lastValue = valueId;
			this._select.value = valueId;
			var selectedValue = WidgetUtil._getCurrentSelectProps(this._select);
			/*
			 * If the new value is not in the select, add it
			 */
			if(!selectedValue || (selectedValue.id != valueId && selectedValue != valueId) && !(selectedValue.id == EditorUtil.UNCONFIGURED && selectedValue.label == null)) {
				    this._possibleValues = this._possibleValues || [];
					this._possibleValues.unshift(value);
					if(this._modifiers.readonly) {
						this._setReadOnlySelectValue(value);
					} else {
						this._bindValuesToSelect(this._possibleValues, this._select, this._image)
					}
					this._select.value = valueId;
				}
			
			if(!noNotify) {
				this._handleSelectChange({target: this._select}, /* doNotPropagateAgain */ true, skipDirtyingEvent);
			}
		},
		
		_fetchValueSet: function() {
			var srh= this._createValueSetHandler();
			this.__workItemAdapter.getValueSet(this.attributeId, srh);
		},
		
		_createValueSetHandler: function() {
			var self= this;
			var serviceObj= {
				success: function(values) {
					if(self.parentWidget && self.parentWidget.isDestroyed) return; // returned after destroyed
					
					/* Make sure the current value is in the values */
					var index = self._select.selectedIndex;
					var currentValue = self._possibleValues[index];
					var found = false;
					for(var i=0;i<values.length; i++) {
						if(values[i].id == currentValue.id) {
							found = true;
							break;
						}						
					}
					if(!found){
						values.unshift(currentValue);
					}
					
					self._possibleValues = values;
					self._bindValuesToSelect(values, self._select, self._image);
				},
				failure: function(errorObj) {
					if(self.parentWidget && self.parentWidget.isDestroyed) return; // returned after destroyed
					self.parentController.handleError(errorObj, "A problem occurred while trying to fetch enumeration.");
				}
			};
			return new ServiceResponseHandler(serviceObj, "success", "failure");
		},
		
		__sentinel: null
	}
);

})();
