/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveAttachedPageAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var ResponseHandler= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;	
var PlanningClient= com.ibm.team.apt.web.client.internal.PlanningClient;	
var Action= com.ibm.team.apt.web.ui.internal.view.plan.actions.Action;

var Assert= com.ibm.team.apt.web.ui.internal.common.Assert;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveAttachedPageAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {
	
	_callCtrl: null,
	_attachedPage: null,
		
	constructor: function(callCtrl, attachedPage) {
		this._callCtrl= callCtrl;
		this._attachedPage= attachedPage;
	},
	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getStyle: function() {
		return Action.STYLE_PUSH;
	},
	
	getIconUrl: function() {
		return null;
	},
	
	getId: function() {
		return "attachedPage.save"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_SAVE_ATTACHED_PAGE;
	},
	
	canHandle: function() {
		return this._attachedPage.isDirty();
	},
	
	handle: function() {
		
		var self= this;
		var serviceCallback= {
			_success: function(result) {
				self._attachedPage.setDirty(false);
				self._attachedPage._displayAttachedPageContent(result.wikiSource, result.pageContent, result.stateId);
			},
			_error: function(error) {
				self._callCtrl.remoteError(error);
			}
		}
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
		responseHandler.setLabel(MSGS.MONITOR_SAVE_ATTACHEDPAGE, this._callCtrl);
		PlanningClient.postAttachedPage(responseHandler, this._attachedPage.getPlanPage().getPlanId(), this._attachedPage.getPageId(), this._attachedPage.getPageStateId(), this._attachedPage._wikiEditor.value);
	},

	__sentinel: null // terminates this class definition
});

})();
