/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.MessageElementViewerItem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem"); //$NON-NLS-1$

(function() {

var ViewModelViewerItem				= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem;

var doc= document;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.MessageElementViewerItem", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem], {

	__messageElement: null,
	__treeLayoutElement: null,

	constructor: function(entry, parentItem, plannedItemsTab, viewer) {
		this.__messageElement= entry.getElement();
	},

	// ---- ViewModelViewerItem implementation -----------------------------------------------------------------------------

	_createContainer: function() {
		var result= doc.createElement("tr"); //$NON-NLS-1$
		dojo.addClass(result, "message"); //$NON-NLS-1$
		return result;
	},

	_createContent: function() {
		var localDoc= doc;

		var rowContainer= this.domNode;
		
		var actionBarCell=localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(actionBarCell, "actionBarCell"); //$NON-NLS-1$
		dojo.addClass(actionBarCell, "info"); //$NON-NLS-1$
		var actionBar= this._createActionBar();
		actionBarCell.appendChild(actionBar);
		rowContainer.appendChild(actionBarCell);

		var markerCell= localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(markerCell, "info"); //$NON-NLS-1$
		rowContainer.appendChild(markerCell);

		var cell= localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(cell, "attribute"); //$NON-NLS-1$
		dojo.addClass(cell, "summary"); //$NON-NLS-1$

		var summaryElement= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(summaryElement, "summary"); //$NON-NLS-1$

		var appendTextTo= summaryElement;
		if ((this.__messageElement.getOptions() & com.ibm.team.apt.ui.structure.MessageElement.CREATE_LINK) != 0) {
			var createLink= localDoc.createElement("a"); //$NON-NLS-1$

			createLink.href= "#"; //$NON-NLS-1$
			this._connect(createLink, "onclick", function(event) { //$NON-NLS-1$
				dojo.stopEvent(event);

				var plan= this.getViewModel().getInput();
				var workItemType= plan.getDefaultWorkItemType();
				if (workItemType != null) {
					var targetGroup= this.getViewModel().readModel(function(readAccessor) {
						return readAccessor.getRootEntry();
					}, this);

					var itemMovePolicy= this._plannedItemsTab.getItemMovePolicy();
					itemMovePolicy.create(targetGroup, workItemType, com.ibm.team.apt.ui.Create.Child);
				}
			});

			appendTextTo= createLink;
			summaryElement.appendChild(createLink);
		}

		
		appendTextTo.appendChild(localDoc.createTextNode(this.__messageElement.getMessage()));
		cell.appendChild(summaryElement);
		this.__treeLayoutElement= summaryElement;

		rowContainer.appendChild(cell);

		this._applyTreeLayout();
	},

	_getTreeLayoutElement: function() {
		return this.__treeLayoutElement;
	},

	__sentinel: null // terminates this class definition
});

})();
