/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.RowElementViewerItem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem"); //$NON-NLS-1$

(function() {

var ViewModelViewerItem				= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem;

var doc= document;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.RowElementViewerItem", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem], {

	_rowElement: null,
	
	constructor: function(entry, parentItem, plannedItemsTab, viewer) {
		this._rowElement= entry.getElement();
	},

	// ---- api ------------------------------------------------------------------------------------------------------------	
	
	isExpanded: function() {
		return true;
	},
	
	// ---- ViewModelViewerItem implementation -----------------------------------------------------------------------------

	_createContainer: function() {
		var result= doc.createElement("tr"); //$NON-NLS-1$
		dojo.addClass(result, "group"); //$NON-NLS-1$
		return result;
	},

	_createContent: function() {
		var placeholder= doc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(placeholder, "actionBarCell"); //$NON-NLS-1$
		this.domNode.appendChild(placeholder);
	},

	_insertChildItem: function(viewerItem, insertBefore) {
		if (insertBefore) {
			this.domNode.insertBefore(viewerItem.domNode, insertBefore);
		} else {
			this.domNode.appendChild(viewerItem.domNode);
		}
	},
	
	_updateContent: function() {
	},

	_createDropTarget: function() {
		return null;
	},
	
	_getFirstChildNode: function() {
		//child[0] is the action bar cell (see _createContent)
		return this.domNode.childNodes.length > 1 ? this.domNode.childNodes[1] : null;
	},

	__sentinel: null // terminates this class definition
});

})();
