/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.BooleanWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");

(function(){

var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.BooleanWidget", [dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/queryeditor/widgets/templates/BooleanWidget.html"),

	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
		this.textTrue = this.messages.buttonTrue;
		this.textFalse = this.messages.buttonFalse;
		
		this.presentation= args.presentation;
		this.selection= args.selection;
	},
	
	postCreate: function() {
		this._setValues(this.selection);
		this._connectListeners();
	},
	
	/* String[] */ getValues: function() {
		var selection= new Array();
		if (this._findRadio("true").checked)
			selection.push(true);
		else if (this._findRadio("false").checked)
			selection.push(false);
		return selection;
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Internals
	
	_setValues: function(values) {
		if (values && values.length > 0) {
			var radio= this._findRadio(values[0].id);
			this._check(radio);
		}
	},
	
	_findRadio: function(value) {
		var inputs= dojo.query('input[value="' + value + '"]', this.domNode);
		return inputs.length > 0 ? inputs[0] : null;
	},
	
	_connectListeners: function() {
		var radios= dojo.query('input[type="radio"]', this.domNode);
		for (var i= 0; i < radios.length; i++) {
			this.connect(radios[i], "onclick", this._handleRadioChange);
		}
	},
	
	_handleRadioChange: function(event) {
		this._check(event.target);
		dojo.publish(EventTopics.QUERY_EDITOR_CHANGED, []);
	},
	
	_check: function(input) {
		var radios= dojo.query('input[type="radio"]', this.domNode);
		for (var i= 0; i < radios.length; i++) {
			radios[i].defaultChecked= false;
		}
		input.checked= input.defaultChecked= true;
	}
	
});
	
})();
