/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.viewers.TableTreeViewer"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.viewers.TableViewer"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.apt.web.ui.internal.viewers.TableTreeViewer", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.viewers.TableViewer], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	__tableBody: null,

	// ---- api ------------------------------------------------------------------------------------------------------------	
	
	// ---- widget implementation ------------------------------------------------------------------------------------------

	postCreate: function() {
		this.inherited(arguments);
	},
	
	destroy: function() {		
		this.inherited(arguments);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
		
	__createRows: function(element, level) {
		if (!level)
			level= 0;
		
		var rows= this.getContentProvider().getChildren(element);
		rows= this.__sort(rows);
		for ( var i = 0; i < rows.length; i++) {
			var rowElement= rows[i];
			
			var row= this.__createRow(rowElement);
			this.__tableBody.appendChild(row)

			var firstCell= row.firstChild;
			dojo.style(firstCell, "paddingLeft",  (level * 16) + "px"); //$NON-NLS-1$ //$NON-NLS-2$
			
			this.__createRows(rowElement, level + 1);
		}
	},
	
	__sentinel: null // terminates this class definition
});

com.ibm.team.apt.web.ui.internal.viewers.TableTreeViewer.constructorArgs= function(tableStyles, labelProvider, contentProvider, columnProvider) {
	return com.ibm.team.apt.web.ui.internal.viewers.TableViewer.constructorArgs(tableStyles, labelProvider, contentProvider, columnProvider);
};

})();
