/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.page.CqWelcome");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "CqPageView");
dojo.requireLocalization("com.ibm.rational.cm.web.ui", "cqLoginController");

dojo.declare(
	"com.ibm.rational.cm.web.ui.page.CqWelcome",
	[ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.rational.cm.web", "ui/page/templates/CqWelcome.html"),

	postMixInProperties:function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "CqPageView", this.lang);
		this.loginStrings = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "cqLoginController", this.lang);
		this.inherited(arguments);
	},
	
	_handleClick: function(){},
	
	/*
	 * Update description in welcome page when login succeeded or error occurred
	 */
	updateMessage: function(message){
		var msg = null, authenticated = false;
		if(message){
			msg = message.errorMsg;
			authenticated = message.authenticated;
		}
		var hasError = (msg && msg.length > 0) ? true : false;

		// show/hide login link
		// if logged in, hide link
		this.loginLink.style.display = (hasError === true || authenticated === true) ? "none" : "";

		// update welcome description
		this.welcomeMsg.innerHTML = (hasError) ? msg : this.messages.WelcomeDesc;
		dojo.toggleClass(this.welcomeMsg, "errorMessage", hasError);
	}
});