/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.widget.ViewletContainer");
dojo.require("jazz.ui.StyledBox");
dojo.require("jazz.ui.styledBox.TrimStyles");
(function() {
/*
 * The viewlet container that houses the viewlet trim, titlebar, etc.
 */
dojo.declare("com.ibm.team.workitem.web.ui2.internal.widget.ViewletContainer",
	[jazz.ui.StyledBox], {
	postCreate: function() {
		this.inherited(arguments);
		if(this.isTrimless) {
			this.setTrim(jazz.ui.styledBox.TrimStyles.NONE);
		} else {
			this.setTrim(jazz.ui.styledBox.TrimStyles.EDITOR);			
		}

		dojo.addClass(this._header, "viewlet-container-header");
	},
	close: function(e) {
		dojo.stopEvent(e);
		if(this.parentWidget._promptToClose({}, /* isClose */ true)) {
			this.inherited(arguments);
		}
	},
	setHeaderIcon: function(path) {
		this.setIcon(path);
	},
	setContent: function(contentNode, headerNode) {
		dojox.data.dom.replaceChildren(this.contentNode, contentNode);
		if(headerNode) {
			dojox.data.dom.replaceChildren(this._headerText, headerNode);			
		}

	},
	_truncate: function() {
		// skip this for DEFECT 74049
	}
});

})();
