/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.Workday"); //$NON-NLS-1$

dojo.require("com.ibm.team.foundation.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.Timespan"); //$NON-NLS-1$

(function() {

var Assert							= com.ibm.team.foundation.Assert;
var Timespan						= com.ibm.team.apt.client.internal.Timespan;

dojo.declare("com.ibm.team.apt.client.internal.Workday", null, { //$NON-NLS-1$

	constructor: function(dto) {
		Assert.isLegal(dto.day >= 1 && dto.day <= 7);

		// see defect 95846
		if (dto.workingTime < 0)
			dto.workingTime= 0;

		if (dto.endTime < dto.workingTime)
			dto.endTime= dto.workingTime;
		
//		Assert.isLegal(dto.workingTime >= 0);
//		Assert.isLegal(dto.workingTime == 0 ? dto.endTime == 0 : dto.endTime > 0);

		this.day= dto.day;
		this.endTime= dto.endTime;
		this.workingTime= dto.workingTime;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	day: null,
	endTime: null,
	workingTime: null,
	
	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;

		return this.day == other.day && this.endTime == other.endTime && this.workingTime == other.workingTime;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
