/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.plancheck.Problem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.common.Severity"); //$NON-NLS-1$

(function() {

var Severity						= com.ibm.team.apt.common.Severity;
	
dojo.declare("com.ibm.team.apt.client.plancheck.Problem", null, { //$NON-NLS-1$
	
	__problemId: null,
	__planElement: null,
	__attributeId: null,
	__message: null,
	__severity: Severity.WARNING,
	
	constructor: function(constructorArgs) {
		dojo.mixin(this, constructorArgs);
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return this.__problemId;
	},
	
	getPlanElement: function() {
		return this.__planElement;
	},
	
	getAttributeId: function() {
		return this.__attributeId;
	},
	
	getMessage: function() {
		return this.__message;
	},
	
	getSeverity: function() {
		return this.__severity;
	},
	
	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.__problemId == other.__problemId && this.__planElement.equals(other.__planElement);
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	_updateSeverity: function(severity) {
		this.__severity= severity;
	},
	
	__sentinel: null // terminates this class definition
});

com.ibm.team.apt.client.plancheck.Problem.forItem= function(problemId, planElement, message) {
	return new com.ibm.team.apt.client.plancheck.Problem({
		__problemId: problemId,
		__planElement: planElement,
		__message: message
	});
};

com.ibm.team.apt.client.plancheck.Problem.forItemAttribute= function(problemId, planElement, attributeId, message) {
	return new com.ibm.team.apt.client.plancheck.Problem({
		__problemId: problemId,
		__planElement: planElement,
		__attributeId: attributeId,
		__message: message
	});
};

})();
