/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.common.ConfigurationElement"); //$NON-NLS-1$

(function() {


dojo.declare("com.ibm.team.apt.common.ConfigurationElement", null, { //$NON-NLS-1$

	constructor: function(configurationDTO) {
		this.id= configurationDTO.id;
		this.name= configurationDTO.name;
		this.description= configurationDTO.description;
		this.implementation= configurationDTO.implementation;

		this.parameters= {};
		dojo.forEach(configurationDTO.parameters, function(parameterDto) {
			var key= parameterDto.key;
			if (!this.parameters[key]) {
				this.parameters[key]= parameterDto.value;
			} else if (!dojo.isArray(this.parameters[key])) {
				this.parameters[key]= [this.parameters[key], parameterDto.value];
			} else {
				this.parameters[key].push(parameterDto.value);
			}
		}, this);
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	id: null,
	name: null,
	description: null,
	implementation: null,

	getConstructor: function() {
		return dojo.getObject(this.implementation);
	},
	
	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.id == other.id;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});


})();
